//
//  ListThreeColumnInternationalDataModel.swift
//  MVMCoreUI
//
//  Created by Kruthika KP on 06/04/20.
//  Copyright © 2020 Verizon Wireless. All rights reserved.
//


public class ListThreeColumnInternationalDataModel: ListItemModel, MoleculeModelProtocol {
    //--------------------------------------------------
    // MARK: - Properties
    //--------------------------------------------------
    
    public static var identifier: String = "list3CIntData"
    public var leftLabel: LabelModel
    public var centerLabel: LabelModel
    public var rightLabel: LabelModel
    public var arrow: ArrowModel
    
    //--------------------------------------------------
    // MARK: - Initializer
    //--------------------------------------------------
    
    public init(leftLabel:LabelModel, centerLabel:LabelModel, rightLabel:LabelModel, arrow:ArrowModel) {
        self.leftLabel = leftLabel
        self.centerLabel = centerLabel
        self.rightLabel = rightLabel
        self.arrow = arrow
        super.init()
    }
    
    //--------------------------------------------------
    // MARK: - Keys
    //--------------------------------------------------
    
    private enum CodingKeys: String, CodingKey {
        case moleculeName
        case leftLabel
        case centerLabel
        case rightLabel
        case arrow
    }
    
    //--------------------------------------------------
    // MARK: - Codec
    //--------------------------------------------------
    
    required public init(from decoder: Decoder) throws {
        let typeContainer = try decoder.container(keyedBy: CodingKeys.self)
        leftLabel = try typeContainer.decode(LabelModel.self, forKey: .leftLabel)
        centerLabel = try typeContainer.decode(LabelModel.self, forKey: .centerLabel)
        rightLabel = try typeContainer.decode(LabelModel.self, forKey: .rightLabel)
        arrow = try typeContainer.decode(ArrowModel.self, forKey: .arrow)
        try super.init(from: decoder)
    }
    
    public override func encode(to encoder: Encoder) throws {
        try super.encode(to: encoder)
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encode(moleculeName, forKey: .moleculeName)
        try container.encode(leftLabel, forKey: .leftLabel)
        try container.encode(centerLabel, forKey: .centerLabel)
        try container.encode(rightLabel, forKey: .rightLabel)
        try container.encode(arrow, forKey: .arrow)
    }
}
